<?php

Yii::app()->autoloader->getAutoloader()->addNamespace('Everzet\Jade', dirname(__FILE__) . '/src/Everzet/Jade');
Yii::app()->autoloader->getAutoloader()->addNamespace('Everzet\Jade\Dumper', dirname(__FILE__) . '/src/Everzet/Jade/Dumper');
Yii::app()->autoloader->getAutoloader()->addNamespace('Everzet\Jade\Visitor', dirname(__FILE__) . '/src/Everzet/Jade/Visitor');
Yii::app()->autoloader->getAutoloader()->addNamespace('Everzet\Jade\Lexer', dirname(__FILE__) . '/src/Everzet/Jade/Lexer');
Yii::app()->autoloader->getAutoloader()->addNamespace('Everzet\Jade\Filter', dirname(__FILE__) . '/src/Everzet/Jade/Filter');

class CJade extends CViewRenderer
{

    /**
     * Parses the source view file and saves the results as another file.
     * @param string $sourceFile the source view file path
     * @param string $viewFile the resulting view file path
     */
    protected function generateViewFile($sourceFile, $viewFile)
    {
        $dumper = new Everzet\Jade\Dumper\PHPDumper();
        $dumper->registerVisitor('tag', new Everzet\Jade\Visitor\AutotagsVisitor());
        $dumper->registerFilter('javascript', new Everzet\Jade\Filter\JavaScriptFilter());
        $dumper->registerFilter('cdata', new Everzet\Jade\Filter\CDATAFilter());
        $dumper->registerFilter('php', new Everzet\Jade\Filter\PHPFilter());
        $dumper->registerFilter('style', new Everzet\Jade\Filter\CSSFilter());
        $parser = new Everzet\Jade\Parser(new Everzet\Jade\Lexer\Lexer());
        $jade   = new Everzet\Jade\Jade($parser, $dumper);
        $sf=file_get_contents($sourceFile);
        file_put_contents($viewFile, $jade->render($sf));
    }
}

